package alexsa;

public class WaitTimer {
	
	private static long
		mark = System.currentTimeMillis();
	public static boolean
		friendly_waiting = true;

	// mark sets the internal time to the current time.
	// Used in conjunction with wait()
	public static void mark() {
		mark = System.currentTimeMillis();
	}
	
	// wait for the given time in milli seconds times MASTER_SPEED starting at the
	// last time mark() was called
	public static void wait(int ms) {
		mark += ms * Preferences.MASTER_SPEED;
		if (friendly_waiting)
			waitFriendly();
		else
			waitUnfriendly();
	}
	
	private static void waitFriendly() {
		while (System.currentTimeMillis() < mark)
			Thread.yield();
	}
	
	private static void waitUnfriendly() {
		while (System.currentTimeMillis() < mark);
	}
	
	// wait for the given time in milli seconds times MASTER_SPEED starting NOW
	public static void waitFor(int ms) {
		long end = System.currentTimeMillis() + ms * Preferences.MASTER_SPEED;
		if (friendly_waiting)
			waitFriendlyUntil(end);
		else
			waitUnfriendlyUntil(end);
	}

	private static void waitFriendlyUntil(long end) {
		while (System.currentTimeMillis() < end)
			Thread.yield();
	}

	private static void waitUnfriendlyUntil(long end) {
		while (System.currentTimeMillis() < end);
	}
}