package alexsa.data;

import java.util.Vector;

public class Tools {

	public static String stripQuotedString(String s) {
		if (s == null || s.length() == 0 || s.charAt(0) != '"')
			return s;
		return s.substring(1, s.lastIndexOf('"'));
	}

	public static Vector splitWithBraces(String s, char splitter, char open, char close) {
		Vector result = new Vector();
		int start = 0,
			tiefe = 0,
			i = 0;
		while (i < s.length()) {
			char c = s.charAt(i);
			if (c == splitter && tiefe <= 0) {
				result.addElement(s.substring(start, i).trim());
				start = i + 1;
			}
			else if (c == open)
				tiefe++;
			else if (c == close)
				tiefe--;
			i++;
		}
		if (start < s.length())
			result.addElement(s.substring(start).trim());
		return result;
	}

	public static String[] split(String S, char c) {
		if (S == null)
			return null;

		if (S.endsWith("\n"))
			S = S.substring(0, S.length() - 1);

		int count = 0;
		boolean InString = false;

		// First: determine how many parts we have
		for (int i = 0; i < S.length(); i++) {
			if (S.charAt(i) == '"')
				InString = !InString;
			else if (!InString && S.charAt(i) == c && (i == 0 || S.charAt(i - 1) != c))
				count ++;
		}

		// Then: split into substrings
		int start = 0,
			end = 0;
		InString = false;
		String[] result = new String[count + 1];
		for (int i = 0; i < count + 1; i ++) {
			end = start;
			while (end < S.length() && (S.charAt(end) != c || InString)) {
				if (S.charAt(end) == '"')
					InString = !InString;
				end ++;
			}
				
//			end = S.indexOf(c, start);
//			if (end < 0)
//				end = S.length();
			result[i] = S.substring(start, end);
			while (end < S.length() && S.charAt(end) == c)
				end ++;
			start = end;
		}
		return result;
	}

	//  r[n,x]\nr[n,elem]
	public static String[] split(String S, String c) {
		if (S == null)
			return null;

		if (S.endsWith("\n"))
			S = S.substring(0, S.length() - 1);

		int start = 0,
			end = 0,
			count = 1;


		// First: determine how many parts we have
		while (start < S.length() && (start = S.indexOf(c, start)) >= 0) {
			start += c.length();
			count++;
		}

		start = 0;
		// Then: split into substrings
		String[] result = new String[count];
		for (int i = 0; i < count; i ++) {
			end = S.indexOf(c, start);
			if (end < 0)
				end = S.length();
			result[i] = S.substring(start, end);
			start = end + c.length();
		}
		return result;
	}

	public static Vector tokenize(String s) {
		s = s.trim();

		Vector v = new Vector();
		int i = 0, l = s.length(), start = 0;
		while (i < l) {
			char c = s.charAt(i);
			i++;
			if (Character.isLetterOrDigit(c))
				while (i < l && Character.isLetterOrDigit(s.charAt(i)))
					i++;
			else if (c == '"')
				while (i < l && s.charAt(i) != '"')
					i++;
			else
				while (i < l &&
					!Character.isLetterOrDigit(s.charAt(i)) &&
					!(s.charAt(i) == ' '))
					i++;
			v.addElement(s.substring(start, i));
			while (i < l && s.charAt(i) == ' ')
				i++;
			start = i;
		}
		return v;
	}

	public final static int readIntFromFloatString(String S, int i) {
		return (S.charAt(i) - '0') * 1000 + Integer.parseInt(S.substring(i+2, i+5), 10);
	}

	public final static StringBuffer intToFloatString(int i) {
		StringBuffer B = new StringBuffer();
		B.append(i / 1000);
		B.append(".");
		i = i % 1000;
		if (i < 100)
			B.append('0');
		if (i < 10)
			B.append('0');
		B.append(i);
		return B;
	}

	public static void replaceInVector(Vector v, String a, String b) {
		if (v != null)
			for (int i = 0; i < v.size(); i++)
		if (((String)v.elementAt(i)).equals(a))
			v.setElementAt(b, i);
	}
}
