package alexsa.data.animation;

import alexsa.data.*;
import alexsa.data.graphs.ShapeGraph;
import alexsa.data.morphing.Morphing;

public class Transition extends Edge {

	public int
		// the number of times this transition was traversed
		passes = 0;

	public Analysis
		analysis = null;
	
	public Transition(ShapeGraph a, ShapeGraph b) {
		source = a;
		target = b;
	}
	
	public String toString() {
		return source.toString() + " -> " + target.toString();
	}
	
	public boolean valid() {
		if (type == BACK_EDGE)
			return passes < alexsa.Preferences.number_of_cycles;

		return passes == 0;
	}
}
