package alexsa.data.graphs;

import java.awt.Color;
import java_cup.runtime.Symbol;

public class Attributes implements Cloneable {
	public final static int
		UNDEFINED	= -1;

	public int
		color = UNDEFINED,
		shape = UNDEFINED,
		style = UNDEFINED;
	
	public Attributes() {
	}
	
	public Attributes(int s) {
		setAttribute(s);
	}
	
	public Object clone() {
		Attributes a = new Attributes();
		a.color = color;
		a.shape = shape;
		a.style = style;
		return a;
	}
	
	public void setAttribute(int s) {
		switch (s) {
			case GraphSymbols.BLACK:
			case GraphSymbols.RED:
				color = s;
				break;
			case GraphSymbols.DOTTED:
			case GraphSymbols.SOLID:
				style = s;
				break;
			case GraphSymbols.BOX:
			case GraphSymbols.ELLIPSE:
				shape = s;
				break;
		}
	}
	
	public static Attributes makeAttribute(Attributes da, int s) {
		if (da == null)
			return new Attributes(s);
		else {
			da.setAttribute(s);
			return da;
		}
	}

	public static Attributes makeAttribute(Attributes da, Symbol s) {
		return makeAttribute(da, s.sym);
	}
	
	public boolean isDotted() {
		return style == GraphSymbols.DOTTED;
	}
	public boolean isSolid() {
		return style == GraphSymbols.SOLID;
	}
	public boolean isRound() {
		return shape == GraphSymbols.ELLIPSE;
	}
	public boolean isRectangular() {
		return shape == GraphSymbols.BOX;
	}
	public Color getColor() {
		switch (color) {
			case GraphSymbols.BLACK:
				return Color.black;
			case GraphSymbols.RED:
				return Color.red;
			default:
				return Color.black;
		}
	}
}
