package alexsa.data.graphs;
import java_cup.runtime.*;


public class GraphScanner implements java_cup.runtime.Scanner, GraphSymbols {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

	public Symbol float2int(String s) {
		int point_index = s.indexOf('.');
		String
			s1 = s.substring(0, point_index),
			s2 = s.substring(point_index + 1);
		return new Symbol(FLOAT_NUMBER, new Integer(s1 + s2));
	}
	public Symbol treatQuotedString(String s) {
		if (s.indexOf("\\\n") < 0)
			return new Symbol(STRING, s.substring(1, s.length() - 1));
		StringBuffer b = new StringBuffer();
		int pos;
		while ((pos = s.indexOf("\\\n")) >= 0) {
			b.append(s.substring(0, pos));
			s = s.substring(pos + 2);
		}
		b.append(s);
		s = b.toString();
		return new Symbol(STRING, s.substring(1, s.length() - 1));
	}
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	public GraphScanner (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	public GraphScanner (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private GraphScanner () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_START,
		/* 13 */ YY_START,
		/* 14 */ YY_START,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_START,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NOT_ACCEPT,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NOT_ACCEPT,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NOT_ACCEPT,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NOT_ACCEPT,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NOT_ACCEPT,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NOT_ACCEPT,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NOT_ACCEPT,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NOT_ACCEPT,
		/* 38 */ YY_NOT_ACCEPT,
		/* 39 */ YY_NOT_ACCEPT,
		/* 40 */ YY_NOT_ACCEPT,
		/* 41 */ YY_NOT_ACCEPT,
		/* 42 */ YY_NOT_ACCEPT,
		/* 43 */ YY_NOT_ACCEPT,
		/* 44 */ YY_NOT_ACCEPT,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NOT_ACCEPT,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"2:9,26,4,2:2,27,2:12,28,2:5,26,2,1,2:11,24,2,23:10,2:7,25:26,2,3,2:2,25,2,7" +
",19,21,13,14,25,5,9,18,25,22,17,25,11,12,8,25,6,15,16,25:3,20,25:2,2:5,10,0")[0];

	private int yy_rmap[] = unpackFromString(1,69,
"0,1,2,1,3,4,1:3,3:2,5,1:3,3:2,1,3:3,2,6,1,7,8,9,10,11,12,13,14,15,16,17,5,1" +
"8,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,4" +
"3,44,45,46,47,48,49,50")[0];

	private int yy_nxt[][] = unpackFromString(51,29,
"1,2,23:2,3,4,45,4,68,4,22,4:2,62,65,58,4:3,47,4:3,5,23,4,6,3,7,-1:30,8,21,2" +
"5,-1,21:5,-1,21:18,-1:5,4:5,-1,4:13,-1,4,-1:8,4:5,-1,4:12,5,35,4,-1:26,11,-" +
"1:10,27,-1:5,29,-1:2,31,33,-1:18,4:5,-1,4:2,9,4:10,-1,4,-1:4,8,21,25,21:6,-" +
"1,21:18,-1:5,4:5,-1,4:9,10,4:3,-1,4,-1:9,37,-1:27,4:5,-1,4:2,15,4:10,-1,4,-" +
"1:15,46,-1:21,4:5,-1,4:11,16,4,-1,4,-1:16,38,-1:20,4:5,-1,4:2,18,4:10,-1,4," +
"-1:19,39,-1:17,4:5,-1,4:3,19,4:9,-1,4,-1:8,4:5,-1,4:5,20,4:7,-1,4,-1:10,40," +
"-1:26,42,-1:35,43,-1:24,44,-1:34,12,-1:28,13,-1:22,14,-1:29,17,-1:24,4:5,-1" +
",4:3,24,4:9,-1,4,-1:16,41,-1:20,4:5,-1,4,26,4:4,54,4:6,-1,4,-1:8,4:5,-1,4:7" +
",28,4:5,-1,4,-1:8,4:5,-1,4:10,30,4:2,-1,4,-1:8,4:5,-1,4:3,32,4:9,-1,4,-1:8," +
"4:5,-1,4:4,34,4:8,-1,4,-1:8,4:5,-1,4:9,36,4:3,-1,4,-1:8,4:5,-1,4:6,48,4:6,-" +
"1,4,-1:8,4:2,49,4:2,-1,4:13,-1,4,-1:8,4:5,-1,4:5,50,4:7,-1,4,-1:8,4:3,51,4," +
"-1,4:13,-1,4,-1:8,4:5,-1,4:3,52,4:9,-1,4,-1:8,4:5,-1,4,53,4:11,-1,4,-1:8,4:" +
"5,-1,4:5,55,4:7,-1,4,-1:8,4:5,-1,4:7,56,4:5,-1,4,-1:8,4:5,-1,4:5,57,4:7,-1," +
"4,-1:8,4:5,-1,4,59,4:11,-1,4,-1:8,4:5,-1,4:6,60,4:6,-1,4,-1:8,4:5,-1,61,4:1" +
"2,-1,4,-1:8,4:5,-1,4:6,63,4:6,-1,4,-1:8,4:5,-1,4:7,64,4:5,-1,4,-1:8,4:2,66," +
"4:2,-1,4:13,-1,4,-1:8,4:5,-1,4:6,67,4:6,-1,4,-1:3");

	public Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

  return new Symbol(EOF);
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -3:
						break;
					case 3:
						{ /*System.out.println("line " + (yyline + 2) + ":");*/ }
					case -4:
						break;
					case 4:
						{ return new Symbol(STRING, yytext()); }
					case -5:
						break;
					case 5:
						{ return new Symbol(INT_NUMBER, new Integer(yytext())); }
					case -6:
						break;
					case 6:
						{ }
					case -7:
						break;
					case 7:
						{ }
					case -8:
						break;
					case 8:
						{ return treatQuotedString(yytext()); }
					case -9:
						break;
					case 9:
						{ return new Symbol(RED, new Symbol(RED)); }
					case -10:
						break;
					case 10:
						{ return new Symbol(BOX, new Symbol(BOX)); }
					case -11:
						break;
					case 11:
						{ return float2int(yytext()); }
					case -12:
						break;
					case 12:
						{ return new Symbol(NODE); }
					case -13:
						break;
					case 13:
						{ return new Symbol(EDGE); }
					case -14:
						break;
					case 14:
						{ return new Symbol(STOP); }
					case -15:
						break;
					case 15:
						{ return new Symbol(SOLID, new Symbol(SOLID)); }
					case -16:
						break;
					case 16:
						{ return new Symbol(BLACK, new Symbol(BLACK)); }
					case -17:
						break;
					case 17:
						{ return new Symbol(GRAPH); }
					case -18:
						break;
					case 18:
						{ return new Symbol(DOTTED, new Symbol(DOTTED)); }
					case -19:
						break;
					case 19:
						{ return new Symbol(ELLIPSE, new Symbol(ELLIPSE)); }
					case -20:
						break;
					case 20:
						{ return new Symbol(PLAINTEXT, new Symbol(PLAINTEXT)); }
					case -21:
						break;
					case 22:
						
					case -22:
						break;
					case 23:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -23:
						break;
					case 24:
						{ return new Symbol(STRING, yytext()); }
					case -24:
						break;
					case 26:
						{ return new Symbol(STRING, yytext()); }
					case -25:
						break;
					case 28:
						{ return new Symbol(STRING, yytext()); }
					case -26:
						break;
					case 30:
						{ return new Symbol(STRING, yytext()); }
					case -27:
						break;
					case 32:
						{ return new Symbol(STRING, yytext()); }
					case -28:
						break;
					case 34:
						{ return new Symbol(STRING, yytext()); }
					case -29:
						break;
					case 36:
						{ return new Symbol(STRING, yytext()); }
					case -30:
						break;
					case 45:
						{ return new Symbol(STRING, yytext()); }
					case -31:
						break;
					case 47:
						{ return new Symbol(STRING, yytext()); }
					case -32:
						break;
					case 48:
						{ return new Symbol(STRING, yytext()); }
					case -33:
						break;
					case 49:
						{ return new Symbol(STRING, yytext()); }
					case -34:
						break;
					case 50:
						{ return new Symbol(STRING, yytext()); }
					case -35:
						break;
					case 51:
						{ return new Symbol(STRING, yytext()); }
					case -36:
						break;
					case 52:
						{ return new Symbol(STRING, yytext()); }
					case -37:
						break;
					case 53:
						{ return new Symbol(STRING, yytext()); }
					case -38:
						break;
					case 54:
						{ return new Symbol(STRING, yytext()); }
					case -39:
						break;
					case 55:
						{ return new Symbol(STRING, yytext()); }
					case -40:
						break;
					case 56:
						{ return new Symbol(STRING, yytext()); }
					case -41:
						break;
					case 57:
						{ return new Symbol(STRING, yytext()); }
					case -42:
						break;
					case 58:
						{ return new Symbol(STRING, yytext()); }
					case -43:
						break;
					case 59:
						{ return new Symbol(STRING, yytext()); }
					case -44:
						break;
					case 60:
						{ return new Symbol(STRING, yytext()); }
					case -45:
						break;
					case 61:
						{ return new Symbol(STRING, yytext()); }
					case -46:
						break;
					case 62:
						{ return new Symbol(STRING, yytext()); }
					case -47:
						break;
					case 63:
						{ return new Symbol(STRING, yytext()); }
					case -48:
						break;
					case 64:
						{ return new Symbol(STRING, yytext()); }
					case -49:
						break;
					case 65:
						{ return new Symbol(STRING, yytext()); }
					case -50:
						break;
					case 66:
						{ return new Symbol(STRING, yytext()); }
					case -51:
						break;
					case 67:
						{ return new Symbol(STRING, yytext()); }
					case -52:
						break;
					case 68:
						{ return new Symbol(STRING, yytext()); }
					case -53:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
