package alexsa.data.morphing;

import java.util.Vector;

import alexsa.data.graphs.Attributes;
import alexsa.data.graphs.EdgeLabel;
import alexsa.data.graphs.GraphNode;
import alexsa.data.graphs.GraphEdge;
import alexsa.data.Edge;

public class Merge extends MultiMorph {
	public GraphNode
		source2 = null;

	public Merge(GraphNode s1, GraphNode s2, GraphNode t) {
		super(s1, t);
		source2 = s2;
	}

	public void init() {
		if (sources == null)
			sources = new GraphNode[2];
		new_edges = new Vector();
		old_edges = new Vector();
		internal_edges = new Vector();

		sources[0] = (GraphNode)source.clone();
		sources[1] = (GraphNode)source2.clone();

		for (int i = 0; i < source.inDegree(); i++) {
			GraphEdge e = (GraphEdge)source.getInEdge(i);
			if (e.source == source2)
				internal_edges.addElement(e);
			else if (getEdge_SourceSignificant((GraphNode)e.source, target, e.label) != null)
			{
				GraphEdge ge = (GraphEdge)e.clone();
				ge.source = e.source;
				ge.target = sources[0];
				sources[0].addInEdge(ge);
			} else
				old_edges.addElement(e);
		}
		for (int i = 0; i < source.outDegree(); i++) {
			GraphEdge e = (GraphEdge)source.getOutEdge(i);
			if (e.target == source2)
				internal_edges.addElement(e);
			else if (getEdge_TargetSignificant(source, (GraphNode)e.target, e.label) != null)
			{
				GraphEdge ge = (GraphEdge)e.clone();
				ge.source = sources[0];
				ge.target = e.target;
				sources[0].addOutEdge(ge);
			} else
				old_edges.addElement(e);
		}

		for (int i = 0; i < source2.inDegree(); i++) {
			GraphEdge e = (GraphEdge)source2.getInEdge(i);
			if (e.source == source)
				continue;
			if (getEdge_SourceSignificant((GraphNode)e.source, target, e.label) != null)
			{
				GraphEdge ge = (GraphEdge)e.clone();
				ge.source = e.source;
				ge.target = sources[1];
				sources[1].addInEdge(ge);
			} else
				old_edges.addElement(e);
		}
		for (int i = 0; i < source2.outDegree(); i++) {
			GraphEdge e = (GraphEdge)source2.getOutEdge(i);
			if (e.target == source)
				continue;
			if (getEdge_TargetSignificant(source2, (GraphNode)e.target, e.label) != null)
			{
				GraphEdge ge = (GraphEdge)e.clone();
				ge.target = e.target;
				ge.source = sources[1];
				sources[1].addOutEdge(ge);
			} else
				old_edges.addElement(e);
		}

		// Now: find all new edges!
		// all self loops are declared as new!
		for (int i = 0; i < target.inDegree(); i++) {
			GraphEdge e = (GraphEdge)target.getInEdge(i);
			if (e.source == target)
				new_edges.addElement(e);
			else {
				if (getEdge_SourceSignificant((GraphNode)e.source, source, e.label) == null &&
					getEdge_SourceSignificant((GraphNode)e.source, source2, e.label) == null)
					new_edges.addElement(e);
			}
		}
		for (int i = 0; i < target.outDegree(); i++) {
			GraphEdge e = (GraphEdge)target.getOutEdge(i);
			if (e.target != target &&
				getEdge_TargetSignificant(source, (GraphNode)e.target, e.label) == null &&
				getEdge_TargetSignificant(source2, (GraphNode)e.target, e.label) == null)
				new_edges.addElement(e);
		}
	}
}