package alexsa.data.tvp;

import java.util.Vector;

public class Action extends FileElement {

	public String
		identifier = null;
	public Vector
		id_list = null;

	public Message
		title = null;
	public Vector
		focus_list = null;
	public Formula
		precondition = null;
	public Vector
		report_messages = null;
	public NewFormula
		new_formula = null;
	public Vector
		update_list = null;
	public Formula
		retain_formula = null;

	public Action(String id, Vector il, Message t, Vector fl, Formula p, Vector rm, NewFormula nf, Vector ul, Formula rt)
	{
		if (id == null)
			nullParameter("Action", "an identifier");
		identifier = id;
		id_list = il;

		title = t;
		focus_list = fl;
		precondition = p;
		report_messages = rm;
		new_formula = nf;
		update_list = ul;
		retain_formula = rt;
	}

	public String toString() {
		return toString("\t");
	}

	public String toString(String tab_chars) {
		StringBuffer b = new StringBuffer();
		b.append("%action ");
		b.append(identifier);
		b.append('(');
		if (id_list != null)
			b.append(printVector(id_list, ','));
		b.append(") {\n");

		if (title != null)
			appendLine(b, tab_chars + "%t ", title);

		if (focus_list != null)
			appendLine(b, tab_chars + "%f {", printVector(focus_list, ','), "}");

		if (precondition != null)
			appendLine(b, tab_chars + "%p ", precondition);

		if (report_messages != null)
			for (int i = 0; i < report_messages.size(); i++)
				appendLine(b, tab_chars, report_messages.elementAt(i));

		if (new_formula != null)
			appendLine(b, tab_chars, new_formula);

		if (update_list != null) {
			b.append(tab_chars + "{\n");
			for (int i = 0; i < update_list.size(); i++)
				appendLine(b, tab_chars + tab_chars, update_list.elementAt(i));
			b.append(tab_chars + "}\n");
		}

		if (retain_formula != null)
			appendLine(b, tab_chars, retain_formula);

		b.append('}');
		return b.toString();
	}

	public String printTitle(Vector vars) {
		if (title == null)
			return identifier;

		Message m = title;
		Vector parts = new Vector();
		parts.addElement(m);
		while (m.head != null) {
			m = m.head;
			parts.addElement(m);
		}
		StringBuffer b = new StringBuffer();
		int i = parts.size() - 1;
		int j = 0;
		while (i >= 0) {
			m = (Message)parts.elementAt(i);
			if (m.predicate != null) {
				if (id_list.indexOf(m.predicate.name) >= 0)
					b.append(vars.elementAt(j++));
				else
					b.append(m.predicate);
			} else
				b.append(m.message);
			i--;
		}
		return b.toString();
	}
}
