package alexsa.data.tvp;

import java.util.Vector;

import alexsa.data.Edge;
import alexsa.data.Node;

public class CfgEdge extends Edge {
	public String
		node_a_id = null,
		node_b_id = null,
		identifier = null,
		code	= null;

	public Vector
		id_list = null;
	

	public CfgEdge(String a, String id, Vector v, String b) {
		if (a == null)
			nullParameter("CFG edge", "a source node identifier");
		if (b == null)
			nullParameter("CFG edge", "a target node identifier");
		if (id == null)
			nullParameter("CFG edge", "an edge identifier");

		node_a_id = a;
		identifier = id;
		node_b_id = b;
		id_list = v;	
	}

	protected void nullParameter(String class_name, String missing_item) {
		throw new NullPointerException(class_name + " requires " +
					   missing_item + ", but none was supplied.");
	}

	public String toString() {
		return node_a_id + " " + identifier + "(" +
			FileElement.printVector(id_list, ',') + ") " + node_b_id;
	}

	public String getAction() {
		return identifier + "(" + FileElement.printVector(id_list, ',') + ")";
	}
}
