package alexsa.data.tvp;

import java.util.Vector;

public class ConsistencyRule extends Declaration {
	public Formula
		formula_a,
		formula_b;

	public ConsistencyRule(Formula a, Formula b) {
		if (a == null)
			nullParameter("Consistency rule", "a formula");
		if (b == null)
			nullParameter("Consistency rule", "a second formula");
		type = CONSISTENCY_RULE;
		formula_a = a;
		formula_b = b;
	}

	public ConsistencyRule(ConsistencyRule cr) {
		formula_a = cr.formula_a != null ? new Formula(cr.formula_a) : null;
		formula_b = cr.formula_b != null ? new Formula(cr.formula_b) : null;
	}

	public void replace(String a, String b) {
		if (formula_a != null)
			formula_a.replace(a, b);
		if (formula_b != null)
			formula_b.replace(a, b);
	}

	public String toString() {
		return "%r " + formula_a + " ==> " + formula_b;
	}
}
