package alexsa.data.tvp;

import java.util.Vector;

public class Flags extends FileElement {
	public final static boolean
		DISPLAY_TRUE_DEFAULT = true,
		DISPLAY_MAYBE_DEFAULT = true,
		DISPLAY_FALSE_DEFAULT = false;

	public Vector
		property_list = null;

	boolean
		display_true = DISPLAY_TRUE_DEFAULT,
		display_maybe = DISPLAY_MAYBE_DEFAULT,
		display_false = DISPLAY_FALSE_DEFAULT;

	public Flags(Vector pl) {
		property_list = pl;
	}
	
	public boolean contains(String s) {
		return property_list.indexOf(s) >= 0;
	}

	public Flags(Flags f) {
		property_list = f.property_list != null ? new Vector(f.property_list) : null;
		display_true = f.display_true;
		display_false = f.display_false;
		display_maybe = f.display_maybe;
	}

	public void replace(String a, String b) {
		alexsa.data.Tools.replaceInVector(property_list, a, b);
	}

	public Flags(Vector pl, Vector d) {
		this(pl);
		if (d != null)
			for (int i = 0; i < d.size(); i++) {
				String S = (String)d.elementAt(i);
				if (S.equals("1"))
					display_true = true;
				else if (S.equals("1/2"))
					display_maybe = true;
				else if (S.equals("0"))
					display_false = true;
		}
	}

	public boolean display_is_default() {
		return
			display_true == DISPLAY_TRUE_DEFAULT &&
			display_maybe == DISPLAY_MAYBE_DEFAULT &&
			display_false == DISPLAY_FALSE_DEFAULT;
	}

	public String toString() {
		if (display_is_default())
			return printVector(property_list);
		else {
			StringBuffer b = new StringBuffer();
			b.append(printVector(property_list));
			if (display_true)
				b.append(" 1");
			if (display_false)
				b.append(" 0");
			if (display_maybe)
				b.append(" 1/2");
			return b.toString();
		}   
	}
}
