package alexsa.data.tvp;

import java.util.Vector;

public class InstrumentationPredicate extends Declaration {

	public Predicate
		predicate = null;
	public Vector
		variables = null;
	public Formula
		formula = null;
	public Flags
		flags = null;

	public InstrumentationPredicate(Predicate p, Vector v, Formula fo, Flags fl) {
		if (p == null)
			nullParameter("Instrumentation predicate", "a predicate");
		if (p == null)
			nullParameter("Instrumentation predicate", "a formula");
		type = INSTRUMENTATION_PREDICATE;
		predicate = p;
		variables = v;
		formula = fo;
		flags = fl;
	}

	/* Copy-constructor, uses also copy-constructors for member variables */
	public InstrumentationPredicate(InstrumentationPredicate ip) {
		predicate = ip.predicate != null ? new Predicate(ip.predicate) : null;
		variables = ip.variables != null ? new Vector(ip.variables) : null;
		formula = ip.formula != null ? new Formula(ip.formula) : null;
		flags = ip.flags != null ? new Flags(ip.flags) : null;
	}

	public void replace(String a, String b) {
		if (predicate != null)
			predicate.replace(a, b);
		alexsa.data.Tools.replaceInVector(variables, a, b);
		if (formula != null)
			formula.replace(a, b);
		if (flags != null)
			flags.replace(a, b);
	}

	public String toString() {
		StringBuffer b = new StringBuffer();
		b.append("%i ");
		b.append(predicate);
		b.append('(');
		b.append(printVector(variables, ','));
		b.append(") = ");
		b.append(formula);
		if (flags != null) {
			b.append(' ');
			b.append(flags);
		}
		return b.toString();
	}
}
