package alexsa.data.tvp;

import java.util.Vector;

public class Predicate extends FileElement {
	public String
		name = null;
	public Vector
		id_list = null;

	public Predicate(String s) {
		this(s, null);
	}

	public Predicate(String s, Vector il) {
		if (s == null)
			nullParameter("Predicate", "an identifier");
		name = s;
		id_list = il;
	}

	public Predicate(Predicate p) {
		name = new String(p.name);
		id_list = p.id_list != null ? new Vector(p.id_list) : null;
	}

	public void replace(String a, String b) {
		if (name.equals(a))
			name = b;
		alexsa.data.Tools.replaceInVector(id_list, a, b);
	}


	public String eval() {
		return toString();
	}

	public String toString() {
		if (id_list == null)
			return name;
		else
			return name + "[" + printVector(id_list, ',') + "]";
	}

	public boolean equals(String s) {
		return name != null ? name.equals(s) : false;
	}

	public boolean equals(Predicate p) {
		if (name == null || ! name.equals(p.name))
			return false;
		if (id_list == null && p.id_list == null)
			return true;
		if (id_list != null && p.id_list != null && id_list.size() == p.id_list.size())
			return true;
		return false;
	}
}
