package alexsa.data.tvp;

import java.util.Vector;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PipedReader;
import java.io.PipedWriter;

import java_cup.runtime.*;
import alexsa.data.FileFormatException;
import alexsa.data.Tools;

import com.ibm.dk.dps.io.*;

public class ProgramLoader {
    
	public Program
		program = null;

	public ProgramLoader(File F)
		throws IOException, FileFormatException
	{
		if (F == null)
			return;

		CPreProcessorStream stream = new CPreProcessorStream(F.getPath());
		
		// To make sure that our PreProcessor finds the necessary files,
		// we add the directory of the given file to the PreProcessor's
		// search path if and only if the original path included the current
		// director (.) and the file's directory is not already part of
		// the path
		String
			include_path = System.getProperty("include"),
			file_dir = F.getParent();
		if ((include_path.equals(".") ||
			include_path.startsWith(".;") ||
			include_path.endsWith(";.") ||
			include_path.indexOf(";.;") >= 0 )
			&&
			include_path.indexOf(file_dir) < 0)
		{
			stream.setSearchPath(System.getProperty("include") + ";" + F.getParent());
		}
		TvpParser parser = new TvpParser(new TvpScanner(stream));

		try {
			Symbol T = parser.parse();
			program = (Program)T.value;
			program.file = new File(F.getPath());
			program.init();
		} catch (Exception e) {
			System.out.println(e);
			e.printStackTrace();
		}
	}
}
