package alexsa.data.tvp;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class SetExpression extends FileElement {
	public final static boolean
		PLUS = true,
		MINUS = false;
	public String
		set_name = null;
	public Vector
		id_list = null;
	public SetExpression
		set_expression1 = null,
		set_expression2 = null;
	public boolean
		Minus = false,
		Plus = false;

	public SetExpression(String s) {
		set_name = s;
	}

	public SetExpression(Vector il) {
		id_list = il;
	}

	public SetExpression(SetExpression a, SetExpression b, boolean plus) {
		if (a == null)
			nullParameter("Set expression (a o b)", "a set expression");
		if (b == null)
			nullParameter("Set expression (a o b)", "a second set expression");
		set_expression1 = a;
		set_expression2 = b;
		if (plus == PLUS)
			Plus = true;
		else
			Minus = true;
	}

	public String toString() {
		if (id_list != null)
			return "{" + printVector(id_list, ',') + "}";
		if (set_name != null)
			return set_name;
		if (set_expression1 != null && set_expression2 != null) {
			if (Minus)
				return set_expression1.toString() + " - " + set_expression2.toString();
			else
				return set_expression1.toString() + " + " + set_expression2.toString();
		}
		return null;
	}

	/* evaluate this set expression and return a vector of the elements
	   contained in the evaluated set expression.
	   In: (Hashtable)sets, usually the identically named variable from
    	   Program.java
	   Out: A Vector containing the elements denoted by the expression.
    	   If an error occured in the evaluation, null is returned.
	*/
	public Vector eval(Hashtable sets) {
		if (id_list != null)
			return id_list;
		if (set_name != null)
			return (Vector)sets.get(set_name);

		Vector
			a = set_expression1.eval(sets),
			b = set_expression2.eval(sets);
		if (a == null || b == null)
			return null;

		Hashtable h = null;
		if (Plus) {
			h = new Hashtable(((a.size() + b.size()) * 4) / 3);
			for (int i = 0; i < a.size(); i++)
				h.put(a.elementAt(i), Boolean.TRUE);
			for (int i = 0; i < b.size(); i++)
				if (h.get(b.elementAt(i)) == null)
					h.put(b.elementAt(i), Boolean.TRUE);
		} else if (Minus) {
			h = new Hashtable((a.size() * 4) / 3);
			for (int i = 0; i < a.size(); i++)
				h.put(a.elementAt(i), Boolean.TRUE);
			for (int i = 0; i < b.size(); i++)
				h.remove(b.elementAt(i));
		} else
			return null;

		Vector r = new Vector(h.size());
		Enumeration e = h.elements();
		while (e.hasMoreElements())
			r.addElement(e.nextElement());
		return r;
	}
}
