package alexsa.data.tvp;
import java_cup.runtime.*;
import com.ibm.dk.dps.io.CPreProcessorStream;


public class TvpScanner implements java_cup.runtime.Scanner, TvpSymbols {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

	/* we need to remember the CPreProcessorStream in order to
		find out the actual file and line number an error occured
	*/
	CPreProcessorStream preprocessorstream = null;
	/* This is a specialized copy of the InputStream-constructor from
	   Scanner.java. JLex doesn't allow overwriting its own constructors,
	   so we implement a new one here
	*/
	public TvpScanner (CPreProcessorStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		preprocessorstream = instream;
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}
	/* If an error occurs, the parser will use these two functions to
	   print out the actual line and file an error occured
	*/
	public int getLine() {
		if (preprocessorstream != null)
	 		return preprocessorstream.getLine(yyline);
		else
			return yyline;
	}
	public String getFile() {
		if (preprocessorstream != null)
	 		return preprocessorstream.getFile(yyline);
		else
			return "[original file]";
	}
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	public TvpScanner (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	public TvpScanner (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private TvpScanner () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int IN_ACTION = 1;
	private final int IN_EDGES = 2;
	private final int IN_NODES = 3;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0,
		84,
		90,
		91
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_START,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NOT_ACCEPT,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NOT_ACCEPT,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NOT_ACCEPT,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NOT_ACCEPT,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NOT_ACCEPT,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NOT_ACCEPT,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NOT_ACCEPT,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NOT_ACCEPT,
		/* 73 */ YY_NOT_ACCEPT,
		/* 74 */ YY_NOT_ACCEPT,
		/* 75 */ YY_NOT_ACCEPT,
		/* 76 */ YY_NOT_ACCEPT,
		/* 77 */ YY_NOT_ACCEPT,
		/* 78 */ YY_NOT_ACCEPT,
		/* 79 */ YY_NOT_ACCEPT,
		/* 80 */ YY_NOT_ACCEPT,
		/* 81 */ YY_NOT_ACCEPT,
		/* 82 */ YY_NOT_ACCEPT,
		/* 83 */ YY_NOT_ACCEPT,
		/* 84 */ YY_NOT_ACCEPT,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NOT_ACCEPT,
		/* 87 */ YY_NOT_ACCEPT,
		/* 88 */ YY_NOT_ACCEPT,
		/* 89 */ YY_NOT_ACCEPT,
		/* 90 */ YY_NOT_ACCEPT,
		/* 91 */ YY_NOT_ACCEPT,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NO_ANCHOR,
		/* 95 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"46:9,47,50,46:2,2,46:12,51,46:5,47,17,1,48,46,29,21,46,11,12,5,3,22,4,46,7," +
"9,6,8,45:7,10,46,20,18,19,23,46,24,45,28,45,25,45:14,27,45:6,13,46,14,46,45" +
",46,37,45,38,45,36,34,43,39,32,45:3,42,40,35,31,45,33,30,41,45:2,44,45:3,15" +
",26,16,46:2,49,0")[0];

	private int yy_rmap[] = unpackFromString(1,96,
"0,1,2,1:2,3,1,4,5:2,1:7,6,7,1:3,5:2,1:5,8,1,9,5,1:4,10,1:2,5,11,1:3,12,1:3," +
"5,1:4,2,13,14,15,16,1,17,12,18,19,20,21,22,23,24,25,13,26,27,28,29,30,31,32" +
",33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50")[0];

	private int yy_nxt[][] = unpackFromString(51,52,
"1,2,3,4,5,6,7,56,8,9,10,11,12,13,14,15,16,17,18,59,62,19,20,21,22,23,24,57," +
"8,65,8:2,60,8,95,8:11,59,25,59,55,3,26,-1:53,27,54:47,-1:2,54,-1:19,28,-1:3" +
"8,8,58,8:2,-1:14,8:2,-1,8:2,-1,8:16,-1:12,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:16" +
",-1:24,30,-1:51,31,-1:34,29,-1,29:46,-1:2,29,-1:19,43,-1:68,73,-1:16,41,-1," +
"41:46,-1:2,41,-1,61,-1,61:2,72,61:43,-1:2,61,-1:47,70,41,-1:8,61,-1,29,-1:5" +
"0,8,-1,8:2,-1:14,8:2,-1,8,32,-1,8:16,-1:14,42,-1:49,8,-1,8:2,-1:14,8:2,-1,8" +
":2,-1,8:10,40,8:5,-1:10,64,-1:53,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:9,49,8:6,-1" +
":25,44,-1:61,33,34,35,36,37,38,-1:2,66,-1:2,68,39,86,-1:47,87,-1:42,51,34,5" +
"2,36,37,38,-1:2,66,-1:2,68,39,86,-1:45,74,-1:44,53,34,-1,36,37,38,-1:2,66,-" +
"1:2,68,39,86,-1:39,34,-1,36,37,38,-1:2,66,-1:2,68,39,86,-1:10,61,-1,61:2,72" +
",61,45,61:41,-1:2,61,-1:41,76,-1:54,46,-1:37,88,-1:58,89,-1:46,78,-1:54,81," +
"-1:53,82,-1:54,47,-1:51,48,-1:54,83,-1:44,50,-1:15,1,2,3,4,5,6,7,56,8,9,10," +
"11,12,13,14,15,16,17,18,59,62,19,20,21,22,23,24,57,8,67,8:2,60,8,95,8:11,59" +
",25,59,55,3,26,-1:6,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:8,63,8:7,-1:42,75,-1:56," +
"77,-1:40,79,-1:53,80,-1:19,1,2,3,4,5,6,7,56,8,9,10,11,12,13,14,15,16,17,18," +
"59,62,19,20,21,22,23,24,57,8,69,8:2,60,8,95,8:11,59,25,59,55,3,26,1,2,3,4,5" +
",6,7,56,8,9,10,11,12,13,14,15,16,17,18,59,62,19,20,21,22,23,24,57,8,71,8:2," +
"60,8,95,8:11,59,25,59,55,3,26,-1:6,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:7,85,8:8," +
"-1:12,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:6,92,8:9,-1:12,8,-1,8:2,-1:14,8:2,-1,8" +
":2,-1,8:3,93,8:12,-1:12,8,-1,8:2,-1:14,8:2,-1,8:2,-1,8:5,94,8:10,-1:6");

	public Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

  return new Symbol(EOF);
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -3:
						break;
					case 3:
						{ /*System.out.println("line " + (yyline + 2) + ":");*/ }
					case -4:
						break;
					case 4:
						{ return new Symbol(PLUS); }
					case -5:
						break;
					case 5:
						{ return new Symbol(MINUS); }
					case -6:
						break;
					case 6:
						{ return new Symbol(MULTIPLY); }
					case -7:
						break;
					case 7:
						{ return new Symbol(TRUE); }
					case -8:
						break;
					case 8:
						{ return new Symbol(STRING, yytext()); }
					case -9:
						break;
					case 9:
						{ return new Symbol(FALSE); }
					case -10:
						break;
					case 10:
						{ return new Symbol(COLON); }
					case -11:
						break;
					case 11:
						{ return new Symbol(LPAREN); }
					case -12:
						break;
					case 12:
						{ return new Symbol(RPAREN); }
					case -13:
						break;
					case 13:
						{ return new Symbol(LBRACK); }
					case -14:
						break;
					case 14:
						{ return new Symbol(RBRACK); }
					case -15:
						break;
					case 15:
						{ return new Symbol(LCURL); }
					case -16:
						break;
					case 16:
						{ return new Symbol(RCURL); }
					case -17:
						break;
					case 17:
						{ return new Symbol(NOT); }
					case -18:
						break;
					case 18:
						{ return new Symbol(EQUALS); }
					case -19:
						break;
					case 19:
						{ return new Symbol(AMPERSAND); }
					case -20:
						break;
					case 20:
						{ return new Symbol(COMMA); }
					case -21:
						break;
					case 21:
						{ return new Symbol(QUESTION); }
					case -22:
						break;
					case 22:
						{ return new Symbol(FORALL); }
					case -23:
						break;
					case 23:
						{ return new Symbol(EXISTS); }
					case -24:
						break;
					case 24:
						{ return new Symbol(OR); }
					case -25:
						break;
					case 25:
						{ }
					case -26:
						break;
					case 26:
						{ }
					case -27:
						break;
					case 27:
						{ return new Symbol(QUOTED_STRING, yytext().substring(1, yytext().length() - 1)); }
					case -28:
						break;
					case 28:
						{ return new Symbol(FOLLOWS); }
					case -29:
						break;
					case 29:
						{ /* System.out.println("Comment: [" + yytext() + "]"); */ }
					case -30:
						break;
					case 30:
						{ return new Symbol(NOT_EQUAL); }
					case -31:
						break;
					case 31:
						{ return new Symbol(DOUBLE_EQUALS); }
					case -32:
						break;
					case 32:
						{ return new Symbol(TC); }
					case -33:
						break;
					case 33:
						{ yybegin(IN_ACTION); return new Symbol(SECTION_DIVIDER); }
					case -34:
						break;
					case 34:
						{ return new Symbol(SET_DECLARATION); }
					case -35:
						break;
					case 35:
						{ return new Symbol(CORE_PREDICATE); }
					case -36:
						break;
					case 36:
						{ return new Symbol(INSTRUMENTATION_PREDICATE); }
					case -37:
						break;
					case 37:
						{ return new Symbol(CONSISTENCY_RULE); }
					case -38:
						break;
					case 38:
						{ return new Symbol(FOCUS); }
					case -39:
						break;
					case 39:
						{ return new Symbol(TITLE); }
					case -40:
						break;
					case 40:
						{ return new Symbol(IN); }
					case -41:
						break;
					case 41:
						{ System.out.println("ignoring preprocessing command: [" + yytext() +"]"); }
					case -42:
						break;
					case 42:
						{ return new Symbol(MAYBE); }
					case -43:
						break;
					case 43:
						{ return new Symbol(IMPLICITLY_FOLLOWS); }
					case -44:
						break;
					case 44:
						{ return new Symbol(FOLLOWS_BOTH); }
					case -45:
						break;
					case 45:
						{ /* System.out.println("Comment: [" + yytext() + "]"); */ }
					case -46:
						break;
					case 46:
						{ return new Symbol(NEW); }
					case -47:
						break;
					case 47:
						{ return new Symbol(RETAIN); }
					case -48:
						break;
					case 48:
						{ return new Symbol(ACTION); }
					case -49:
						break;
					case 49:
						{ return new Symbol(FOREACH); }
					case -50:
						break;
					case 50:
						{ return new Symbol(MESSAGE); }
					case -51:
						break;
					case 51:
						{ yybegin(IN_EDGES); return new Symbol(SECTION_DIVIDER); }
					case -52:
						break;
					case 52:
						{ return new Symbol(PRECONDITION); }
					case -53:
						break;
					case 53:
						{ yybegin(IN_NODES); return new Symbol(SECTION_DIVIDER); }
					case -54:
						break;
					case 55:
						
					case -55:
						break;
					case 56:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -56:
						break;
					case 57:
						{ return new Symbol(STRING, yytext()); }
					case -57:
						break;
					case 59:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -58:
						break;
					case 60:
						{ return new Symbol(STRING, yytext()); }
					case -59:
						break;
					case 62:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -60:
						break;
					case 63:
						{ return new Symbol(STRING, yytext()); }
					case -61:
						break;
					case 65:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -62:
						break;
					case 67:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -63:
						break;
					case 69:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -64:
						break;
					case 71:
						{ System.out.println("ignored char: " + yytext() + " (decimal: " + (int)yytext().charAt(0) +")"); }
					case -65:
						break;
					case 85:
						{ return new Symbol(STRING, yytext()); }
					case -66:
						break;
					case 92:
						{ return new Symbol(STRING, yytext()); }
					case -67:
						break;
					case 93:
						{ return new Symbol(STRING, yytext()); }
					case -68:
						break;
					case 94:
						{ return new Symbol(STRING, yytext()); }
					case -69:
						break;
					case 95:
						{ return new Symbol(STRING, yytext()); }
					case -70:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
