package alexsa.data.tvp;

import java.util.Vector;

public class Update extends FileElement {

    public Predicate
	predicate = null;
    public Vector
	var_list = null;
    public Formula
	formula = null;

    public Iterator
	iterator = null;
    public Vector
	update_formulae = null;

    public Update(Predicate p, Vector v, Formula f) {
	if (p == null)
	    nullParameter("Update", "a predicate");
	if (f == null)
	    nullParameter("Update", "a formula");
	predicate = p;
	var_list = v;
	formula = f;
    }

    public Update(Iterator i, Vector v) {
	if (i == null)
	    nullParameter("Update", "an iterator");
	iterator = i;
	update_formulae = v;
    }

    public String toString() {
	if (predicate != null)
	    return predicate +
		"(" + printVector(var_list, ',') + ") = " +
		formula;
	else
	    return "foreach (" + iterator + ") {" +
		printVector(update_formulae) + "}";
    }
}
