package alexsa.data.tvs;

import java.util.Vector;

import alexsa.data.tvp.Kleene;

public class TvsNode {
	public Kleene
		value = null;
	
	public String
		id = null;
	
	public int
		dot_value = -1;
	
	public Vector
		node_list = null;
	
	public TvsNode(String s) {
		id = s;
	}
	
	public TvsNode(String s, Kleene k) {
		id = s;
		if (k == Kleene.KLEENE_TRUE)
			dot_value = 1;
		else if (k == Kleene.KLEENE_FALSE)
			dot_value = 0;
	}
	
	public TvsNode(Vector v) {
		node_list = v;
	}
	
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(id);
		if (dot_value != -1) {
			buf.append('.');
			buf.append(dot_value);
		} else if (value != null) {
			buf.append(':');
			buf.append(value);
		}
		return buf.toString();
	}
}