package alexsa.gui.codeview;

import java.util.Vector;

import alexsa.data.tvp.CfgEdge;
import alexsa.data.tvp.CfgNode;
import alexsa.data.Edge;
import alexsa.data.Node;

public class DisplayLine {
	String
		label = null,
		code = null,
		target = null;
	int
		indention = 0,
		detour_index = -1;
	CfgEdge
		cfg_edge = null;

	private static int
		max_label_width = 0;
		
	public DisplayLine(String l, String c, int x, CfgEdge ce) {
		label = l;
		if (label != null && label.length() > max_label_width)
			max_label_width = label.length();
		code = c;
		indention = x;
		cfg_edge = ce;
	}

	public DisplayLine(String l, String c, int x, CfgEdge ce, String go_to) {
		this(l, c, x, ce);
		target = go_to;
	}
	
	public String toString() {
		StringBuffer b = new StringBuffer();
		if (label != null) {
			for (int i = max_label_width - label.length(); i > 0; i--)
				b.append(' ');
			b.append(label);
			b.append("  ");
		} else
			for (int i = max_label_width + 2; i > 0; i--)
				b.append(' ');

		for (int i = indention; i > 0; i--)
			b.append(alexsa.Preferences.code_view_indention);
		if (target == null)
			b.append(code);
		else {
			b.append(code);
			b.append(" goto ");
			b.append(target);
			b.append(';');
		}
		return b.toString();
	}
}

