package alexsa.gui.codeview;

import java.util.Vector;

import alexsa.data.tvp.CfgEdge;
import alexsa.data.tvp.CfgNode;
import alexsa.data.tvp.Program;
import alexsa.data.Edge;
import alexsa.data.Node;

class GeneralIfElseStatement extends ComplexNode {
	CfgEdge
		if_branch = null,
		else_branch = null;
	
	GeneralIfElseStatement(Node n, Program program, int inner_index, int outer_index) {
		super(n, program);
		if (inner_index != -1) {
			if_branch = (CfgEdge)n.getOutEdge(inner_index);
			else_branch = (CfgEdge)n.getOutEdge(outer_index);
		} else {
			if_branch = (CfgEdge)n.getOutEdge(0);
			else_branch = (CfgEdge)n.getOutEdge(1);
		}

		if (n == program.start_node)
			program.start_node = this;
	}
	
	public void replaceInOutEdges(Node old_node, Node new_node) {
		super.replaceInOutEdges(old_node, new_node);
		if (if_branch.target == old_node)
			if_branch.target = new_node;
		if (else_branch.target == old_node)
			else_branch.target = new_node;
	}

	public void createDisplayLines(Vector lines, int x) {
		if (color != Node.WHITE)
			return;
		color = Node.GRAY;
		addLine(lines, name, "if (" + if_branch.code + ")", x, if_branch);
		addLine(lines, null, "goto " + if_branch.target.name + ";", x + 1, if_branch);
		addLine(lines, null, "else", x, null);
		addLine(lines, null, "goto " + else_branch.target.name + ";", x + 1, null);
		((CfgNode)if_branch.target).createDisplayLines(lines, x);
		((CfgNode)else_branch.target).createDisplayLines(lines, x);
		color = Node.BLACK;
	}

}
