package alexsa.gui.codeview;

import java.util.Vector;

import alexsa.data.tvp.CfgEdge;
import alexsa.data.tvp.CfgNode;
import alexsa.data.tvp.Program;
import alexsa.data.Edge;
import alexsa.data.Node;

class IfStatement extends ComplexNode {
	CfgEdge
		if_branch = null,
		next_after_if_branch = null;
	
	IfStatement(Node n, Program program, int inner_index, int outer_index) {
		super(n, program);
		if_branch = (CfgEdge)n.getOutEdge(inner_index);
		next_after_if_branch = (CfgEdge)n.getOutEdge(outer_index);

		if (n == program.start_node)
			program.start_node = this;
	}
	
	public void replaceInOutEdges(Node old_node, Node new_node) {
		super.replaceInOutEdges(old_node, new_node);
		if (if_branch.target == old_node)
			if_branch.target = new_node;
		if (next_after_if_branch.target == old_node)
			next_after_if_branch.target = new_node;
	}

	public void createDisplayLines(Vector lines, int x) {
		if (color != Node.WHITE)
			return;
		color = Node.GRAY;
		boolean next_was_white = next_after_if_branch.target.color == Node.WHITE;
		if (next_was_white)
			next_after_if_branch.target.color = Node.GRAY;
		addLine(lines, name, "if (" + if_branch.code + ") {", x, if_branch);
		((CfgNode)if_branch.target).createDisplayLines(lines, x + 1);
		DisplayLine brace = addLine(lines, null, "}", x, next_after_if_branch, null);
//		DisplayLine brace = addLine(lines, null, "}", x, next_after_if_branch, next_after_if_branch.target.name);
		brace.detour_index = lines.size();
		if (next_was_white)
			next_after_if_branch.target.color = Node.WHITE;
		((CfgNode)next_after_if_branch.target).createDisplayLines(lines, x);
		color = Node.BLACK;
	}

}
