package alexsa.gui.codeview;

import java.util.Vector;

import alexsa.data.tvp.CfgEdge;
import alexsa.data.tvp.CfgNode;
import alexsa.data.tvp.Program;
import alexsa.data.Edge;
import alexsa.data.Node;

class SimpleIfElseStatement extends ComplexNode {
	CfgEdge
		if_branch = null,
		else_branch = null;
	CfgNode
		joining_point = null;
	
	SimpleIfElseStatement(Node n, Program program, int inner_index, int outer_index,
		CfgNode join_point)
	{
		super(n, program);
		if_branch = (CfgEdge)n.getOutEdge(inner_index);
		else_branch = (CfgEdge)n.getOutEdge(outer_index);
		
		joining_point = join_point;

		if (n == program.start_node)
			program.start_node = this;
	}
	
	public void replaceInOutEdges(Node old_node, Node new_node) {
		super.replaceInOutEdges(old_node, new_node);
		if (if_branch.target == old_node)
			if_branch.target = new_node;
		if (else_branch.target == old_node)
			else_branch.target = new_node;
		if (old_node instanceof CfgNode && new_node instanceof CfgNode &&
			joining_point == (CfgNode)old_node)
			joining_point = (CfgNode)new_node;
	}

	public void createDisplayLines(Vector lines, int x) {
		if (color != Node.WHITE)
			return;
		color = Node.GRAY;
		joining_point.color = Node.GRAY;
		addLine(lines, name, "if (" + if_branch.code + ") {", x, if_branch);
			((CfgNode)if_branch.target).createDisplayLines(lines, x + 1);
		DisplayLine brace1 = addLine(lines, null, "} else {", x, null, joining_point.name);
			((CfgNode)else_branch.target).createDisplayLines(lines, x + 1);
		DisplayLine brace2 = addLine(lines, null, "}", x, null, joining_point.name);
		brace1.detour_index = lines.size();
		brace2.detour_index = lines.size();
		joining_point.color = Node.WHITE;
		joining_point.createDisplayLines(lines, x);
		color = Node.BLACK;
	}

}
