package alexsa.gui.codeview;

import java.util.Vector;

import alexsa.data.tvp.CfgEdge;
import alexsa.data.tvp.CfgNode;
import alexsa.data.tvp.Program;
import alexsa.data.Edge;
import alexsa.data.Node;

class WhileLoop extends ComplexNode {
	CfgEdge
		while_condition = null;
	CfgNode
		goto_on_exit = null;

	WhileLoop(Node n, Program program, int inner_index, int outer_index) {
		super(n, program);
		while_condition = (CfgEdge)n.getOutEdge(inner_index);
		goto_on_exit = (CfgNode)n.getOutEdge(outer_index).target;

		if (n == program.start_node)
			program.start_node = this;
	}

	public void replaceInOutEdges(Node old_node, Node new_node) {
		super.replaceInOutEdges(old_node, new_node);
		if (while_condition.target == old_node)
			while_condition.target = new_node;
		if (old_node instanceof CfgNode && new_node instanceof CfgNode &&
			goto_on_exit == (CfgNode)old_node)
			goto_on_exit = (CfgNode)new_node;
	}

	public void createDisplayLines(Vector lines, int x) {
		if (color != Node.WHITE)
			return;
		color = Node.GRAY;
		boolean exit_was_white = goto_on_exit.color == Node.WHITE;
		if (exit_was_white)
			goto_on_exit.color = Node.GRAY;
		int start_of_loop = lines.size();
		addLine(lines, name, "while (" + while_condition.code + ") {", x, while_condition);
			((CfgNode)while_condition.target).createDisplayLines(lines, x + 1);
		DisplayLine brace = addLine(lines, null, "}", x, null);
		brace.detour_index = start_of_loop;
		if (exit_was_white)
			goto_on_exit.color = Node.WHITE;
		goto_on_exit.createDisplayLines(lines, x);
		color = Node.BLACK;
	}
}
