package alexsa.gui.menus;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class FMenuBar extends JMenuBar implements ActionListener
{
	private MenuCommander
		commander = null;

	public FMenuBar(MenuCommander c) {
		commander = c;
	}


	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source instanceof FMenuItem && commander != null)
			commander.doCommand (((FMenuItem) source).getCommandNumber());
	}

	public void updateMenus() {
		for (int i = getMenuCount() - 1; i >= 0; i--)
			updateMenu(getMenu(i));
	}

	private void updateMenu(JMenu menu) {
		for (int i = menu.getItemCount() - 1; i >= 0; i--) {
			JMenuItem item = menu.getItem(i);
			
			if (item instanceof FMenuItem) {
				int cmdNum = ((FMenuItem) item).getCommandNumber();
				item.setEnabled(commander.menuItemState(cmdNum));
				String oldLabel = item.getText();
				String newLabel = commander.menuItemName(cmdNum, oldLabel);
				if (newLabel != oldLabel)
					item.setText(newLabel);
			} else if (item instanceof JMenu && item != menu)
				updateMenu((JMenu) item);
		}
		
		if (menu instanceof FMenu) {
			int cmdNum = ((FMenu) menu).getCommandNumber();
			menu.setEnabled(commander.menuItemState(cmdNum));
			String oldLabel = menu.getText();
			String newLabel = commander.menuItemName(cmdNum, oldLabel);
			if (newLabel != oldLabel)
				menu.setText(newLabel);
		}
	}

}
