package alexsa.gui.menus;

/* This interface simplifies some tasks with the menubar.
   Alexsa, the main class, will implement this function.
   It will thus implement the three functions, where
   menuItemState will be responsible for determining, whether
   a given command should be enabled or not and menuItemName
   should return a new String for a command (if applicable)
   or oldName if else.
   
   The way the menus are organized, a simple call of
   FMenuBar.updateMenus will query all menu commands about their
   current state and name.
*/

public interface MenuCommander {

	public void doCommand(int cmdNum);
	public boolean menuItemState(int cmdNum);
	public String menuItemName(int cmdNum, String oldName);

}
