package alexsa.gui.menus;

import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.KeyStroke;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;

import alexsa.Debug;

public class StandardMenuBar extends FMenuBar implements Commands {
	
	class ExportMenu extends FMenu {
		public ExportMenu(ActionListener l) {
			super("Export", cmd_ExportMenu, l);
			addItem("Code view...", 0, cmd_ExportCodeView);
			addItem("Visual execution...", 0, cmd_ExportTraversion);
		}
	}

	class FileMenu extends FMenu {
		public FileMenu(ActionListener l) {
			super("File", cmd_FileMenu, l);
 	      	addItem("Open...", KeyEvent.VK_O, cmd_Open);
			addItem("Close", KeyEvent.VK_W, cmd_Close);
			add(new ExportMenu(l));
			addItem("Quit", KeyEvent.VK_Q, cmd_Quit);
		}
	}
	
	class ViewMenu extends FMenu {
		public ViewMenu(ActionListener l) {
			super("View", cmd_ViewMenu, l);
	       	addItem("Sets", cmd_ViewSets);
   	    	addItem("Core predicates", cmd_ViewCorePredicates);
   	    	addItem("Instrumentation predicates", cmd_ViewInstrumentationPredicates);
   	    	addItem("Explicit consistency rules", cmd_ViewConsistencyRules);
   	    	addItem("Actions", cmd_ViewActions);
		}
 	}

	class OptionsMenu extends FMenu {
		public OptionsMenu(ActionListener l) {
			super("Options", cmd_OptionsMenu, l);
	       	addItem("Animation", cmd_PrefsAnimation);
	       	addItem("Miscellaneous", cmd_PrefsMisc);
			addSeparator();
	       	addItem("Save preferences", cmd_SavePrefs);
		}
 	}

	class AnimateMenu extends FMenu {
		public AnimateMenu(ActionListener l) {
			super("Animate", cmd_AnimateMenu, l);
	       	addItem("Start new animation", KeyEvent.VK_R, cmd_Run);
   	    	addItem("Pause/Continue Animation", KeyEvent.VK_A, cmd_PauseContinueAnimation);
   	    	if (Debug.OFFER_DEBUGGING_OPERATION) {
   	    		addSeparator();
   	    		addItem("Special debugging operation", KeyEvent.VK_X, cmd_DebugFunction);
   	    	}
		}
	}

	public StandardMenuBar(MenuCommander c)
	{
		super(c);
	
		add(new FileMenu(this));
		add(new ViewMenu(this));
		add(new OptionsMenu(this));
		add(new AnimateMenu(this));
		
	}


}
